﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace TestDashLine
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            InitializeChart();
        }
        List<int> valList;
        List<Color> colorList;
        List<System.Drawing.Drawing2D.DashStyle> dslist;
        private void InitializeChart()
        {

            tChart1.Aspect.View3D = false;
            tChart1.Dock = DockStyle.Fill;

            DQLine myCustomLine = new DQLine(tChart1.Chart);
            myCustomLine.LinePen.Width = 3;
            myCustomLine.Pointer.Visible = true;

            myCustomLine.Pointer.Style = Steema.TeeChart.Styles.PointerStyles.DownTriangle;
            myCustomLine.Pointer.Pen.Style = System.Drawing.Drawing2D.DashStyle.Dot;
            myCustomLine.ColorEachLine = true;

            myCustomLine.Pointer.Color = Color.Black;
            myCustomLine.Pointer.HorizSize = 4;
            myCustomLine.Pointer.VertSize = 4;
            myCustomLine.Pointer.Visible = true;
            myCustomLine.LinePen.Width = 3;
            myCustomLine.Marks.Visible = true;

            DateTime wd = DateTime.Now;
            TimeSpan TwentyHours = new TimeSpan(40, 0, 0);
            TimeSpan OneHour = new TimeSpan(1, 0, 0);


            // Not 3D!
            this.tChart1.Aspect.View3D = false;

            wd.Subtract(TwentyHours);
            valList = new List<int>(new int[] { 81, 81, 81, 13, 13, 13, 13, 53 });
            colorList = new List<Color>(new Color[] { Color.Red, Color.Green, Color.Blue, Color.HotPink, Color.Black, Color.Purple, Color.Magenta, Color.Cyan });
            dslist = new List<System.Drawing.Drawing2D.DashStyle>(new System.Drawing.Drawing2D.DashStyle[] { System.Drawing.Drawing2D.DashStyle.DashDot, System.Drawing.Drawing2D.DashStyle.DashDot, System.Drawing.Drawing2D.DashStyle.DashDotDot, System.Drawing.Drawing2D.DashStyle.Dot, System.Drawing.Drawing2D.DashStyle.Solid, System.Drawing.Drawing2D.DashStyle.Dot, System.Drawing.Drawing2D.DashStyle.Dash, System.Drawing.Drawing2D.DashStyle.Solid });
            int index = 0;
            foreach (int val in valList)
            {
                myCustomLine.Add(index, val, dslist[index], "", colorList[index]);//,colorList[index],dslist[index] );
                wd = wd.Add(OneHour);
                index++;

            }
            ((Steema.TeeChart.Styles.Line)this.tChart1.Series[0]).Pointer.Pen.Color = Color.Pink;
            ((Steema.TeeChart.Styles.Line)this.tChart1.Series[0]).Color = Color.Green;

              myCustomLine.GetPointerStyle += new Steema.TeeChart.Styles.CustomPoint.GetPointerStyleEventHandler(myCustomLine_GetPointerStyle);

              tChart1.Header.Visible = true;
              Bitmap bitmap = tChart1.Bitmap;
        }

        void myCustomLine_GetPointerStyle(Steema.TeeChart.Styles.CustomPoint series, Steema.TeeChart.Styles.Custom.GetPointerStyleEventArgs e)
        {
            DQLine dqSeries = series as DQLine;
            if (dqSeries != null)
            {
                if (e.ValueIndex != -1)
                {
                    int nextIndex = e.ValueIndex +1;
                    if (nextIndex < (series.LastVisibleIndex + 1))
                    {
                        series.Pointer.Color = colorList[nextIndex];
                        series.Pointer.Pen.Color = series.Pointer.Color;
                        series.Color = series.Pointer.Color;
                        series.LinePen.Style = dslist[nextIndex];
                    }
                    else if(nextIndex ==(series.LastVisibleIndex+1))
                    {
                         series.Pointer.Color = colorList[series.FirstVisibleIndex];
                        series.Pointer.Pen.Color = series.Pointer.Color;
                        series.Color = series.Pointer.Color;
                        series.LinePen.Style = dslist[series.FirstVisibleIndex];
                    }

                }
            }
        }

    }

}

